/*******************************************
紅音製作所 www5.big.or.jp/~high/VENIO/
COPYRIGHT(C)VENIO WORKS ALL RIGHTS RESERVED.
*******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_opengl.h"

#define REC 64			//図形の大きさ
#define GTRE 0x84F5 //任意サイズテクスチャ可

SDL_Surface *mWIN; //メインウィンドウ
Uint32 cntA,cntB,now,lev,wit;//FPS用

const int WIW=480;	//ウィンドウ-幅
const int WIH=320;	//ウィンドウ-高さ

const GLint R72=72;	//非２の累乗テクスチャサイズ
const GLint R48=48;
const GLint R24=24;

GLuint texA=0;//テクスチャ
GLuint texB=0;
GLuint texC=0;
GLuint texD=0;
GLuint texE=0;
GLuint texF=0;
//------------------------------------------------------------------------------２の累乗を返す
int Pot(int inSize)
{
int outSize=1;
while(outSize<inSize) outSize<<=1;
return outSize;
}
//------------------------------------------------------------------------------テクスチャ作成
void creatTex(char *file,GLuint *tex)
{
GLuint textures;
SDL_Surface *imgSrc[2];
SDL_Rect area;
Uint32 alpFlg;
Uint8  alpGet;

//画像読み込み
imgSrc[0]=IMG_Load(file);
if(imgSrc[0]==NULL)SDL_Quit();//読み込まれなかったら終了

//imgSrc[0]を変換
imgSrc[1]=SDL_CreateRGBSurface
  (
  SDL_SWSURFACE, Pot(imgSrc[0]->w), Pot(imgSrc[0]->h), 32,
  #if SDL_BYTEORDER==SDL_LIL_ENDIAN
    0x000000FF, 0x0000FF00, 0x00FF0000, 0xFF000000
  #else
    0xFF000000, 0x00FF0000, 0x0000FF00, 0x000000FF
	#endif
	);
if(imgSrc[1]==NULL)SDL_Quit();
//アルファ取得
alpFlg=imgSrc[0]->flags&(SDL_SRCALPHA | SDL_RLEACCELOK);
alpGet=imgSrc[0]->format->alpha;
if( (alpFlg&SDL_SRCALPHA)==SDL_SRCALPHA )SDL_SetAlpha(imgSrc[0], 0, 0);

area.x=0;  area.y=0;
area.w=imgSrc[0]->w; area.h=imgSrc[0]->h;
SDL_BlitSurface(imgSrc[0], &area, imgSrc[1], &area);

//テクスチャ作成
glGenTextures(1, &textures);
glBindTexture(GL_TEXTURE_2D, textures);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);//拡大時
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);//縮小時
glTexImage2D
  (
  GL_TEXTURE_2D,//2Dテクスチャ
  0,
  GL_RGBA,//GL_RGBA
  imgSrc[1]->w, imgSrc[1]->h,//テクスチャ幅・高さ
  0,//ボーダー
  GL_RGBA,//pixelsの渡すデータ形式
  GL_UNSIGNED_BYTE,//pixelsのデータ型
  imgSrc[1]->pixels
  );
*tex=textures; if(*tex==0)SDL_Quit();

int num;//Surface解放
for(num=0; num<2; num++)SDL_FreeSurface(imgSrc[num]);
}
//------------------------------------------------------------------------------テクスチャ作成その２
void creatTex2(char *file,GLuint *tex)
{
GLuint textures;
SDL_Surface *imgSrc[2];
SDL_Rect area;
Uint32 alpFlg;
Uint8  alpGet;

//画像読み込み
imgSrc[0]=IMG_Load(file);
if(imgSrc[0]==NULL)SDL_Quit();//読み込まれなかったら終了

//imgSrc[0]を変換
imgSrc[1]=SDL_CreateRGBSurface
	(
	SDL_SWSURFACE, imgSrc[0]->w, imgSrc[0]->h, 32,
	#if SDL_BYTEORDER==SDL_LIL_ENDIAN
		0x000000FF, 0x0000FF00, 0x00FF0000, 0xFF000000
	#else
		0xFF000000, 0x00FF0000, 0x0000FF00, 0x000000FF
	#endif
	);
if(imgSrc[1]==NULL)SDL_Quit();
//アルファ取得
alpFlg=imgSrc[0]->flags&(SDL_SRCALPHA | SDL_RLEACCELOK);
alpGet=imgSrc[0]->format->alpha;
if( (alpFlg&SDL_SRCALPHA)==SDL_SRCALPHA )SDL_SetAlpha(imgSrc[0], 0, 0);

area.x=0;  area.y=0;
area.w=imgSrc[0]->w;  area.h=imgSrc[0]->h;
SDL_BlitSurface(imgSrc[0], &area, imgSrc[1], &area);

//テクスチャ作成
glGenTextures(1, &textures);
glEnable(GTRE);//任意のテクスチャON
glBindTexture(GTRE, textures);
glTexParameteri(GTRE, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
glTexParameteri(GTRE, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
glTexImage2D
  (
  GTRE, 0, GL_RGBA,
  imgSrc[1]->w, imgSrc[1]->h,
  0, GL_RGBA, GL_UNSIGNED_BYTE,
  imgSrc[1]->pixels
  );
glDisable(GTRE);//任意のテクスチャOFF
*tex=textures; if(*tex==0)SDL_Quit();

int num;//Surface解放
for(num=0; num<2; num++)SDL_FreeSurface(imgSrc[num]);
}
//------------------------------------------------------------------------------初期化
void inits()
{
if(SDL_Init(SDL_INIT_VIDEO)==-1)	SDL_Quit();//初期化失敗で終了
//メインウィンドウ作成
SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);
mWIN=SDL_SetVideoMode(WIW,WIH,32,SDL_OPENGL	//|SDL_FULLSCREEN
);
SDL_WM_SetCaption("OpenGL Test Window", NULL);//windowの名前

glBlendFunc(GL_SRC_ALPHA,	GL_ONE_MINUS_SRC_ALPHA);//アルファの設定
glEnable(GL_BLEND);//アルファのブレンド有効
glClearColor( 0.0, 0.0, 0.0, 1.0 );//バックの色
glShadeModel(GL_FLAT);//シェーディングモード
glMatrixMode(GL_PROJECTION);
glOrtho(0.0, WIW, WIH, 0.0, 0.0, 1.0);
glMatrixMode(GL_MODELVIEW);
//テクスチャ作成
creatTex("testGL.app/Contents/Resources/image.bmp", &texA);
creatTex("testGL.app/Contents/Resources/image.gif", &texB);
creatTex("testGL.app/Contents/Resources/image.png", &texC);
creatTex2("testGL.app/Contents/Resources/img72.bmp", &texD);
creatTex2("testGL.app/Contents/Resources/img48.gif", &texE);
creatTex2("testGL.app/Contents/Resources/img24.png", &texF);
}
//------------------------------------------------------------------------------終了イベント
int endKeys()
{
SDL_Event Qevents;
if(SDL_PollEvent(&Qevents))
switch(Qevents.type)
	{
	case SDL_QUIT:		//ウィンドウのボタン
		return 0;	
	case SDL_KEYDOWN:	//escキー
		if(Qevents.key.keysym.sym==SDLK_ESCAPE)	return 0;
	}
return 1;
}
//------------------------------------------------------------------------------バック地と中心線
void back()
{
glClear(GL_COLOR_BUFFER_BIT);//バック地を黒で塗り潰し
glLoadIdentity();
//ウィンドウの中心線の描画
glBegin(GL_LINES);
glColor3d(0.0,	0.0,	1.0);
	glVertex2i(0,WIH/2);	glVertex2i(WIW,WIH/2);
	glVertex2i(WIW/2,0);	glVertex2i(WIW/2,WIH);
glEnd();
}
//------------------------------------------------------------------------------物体A
void modelA()
{
glColor3d(1.0, 0.0, 0.0);//色
glBegin(GL_LINE_LOOP);
	glVertex2i(-REC*0.5,-REC*0.5);
	glVertex2i( REC*0.5,-REC*0.5);
	glVertex2i( REC*0.5, REC*0.5);
	glVertex2i(-REC*0.5, REC*0.5);
glEnd();
}
//------------------------------------------------------------------------------物体Aの描画
void modelA_fix()
{
glLoadIdentity();
glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
modelA();
}
//------------------------------------------------------------------------------物体Aの移動
void modelA_move()
{
glLoadIdentity();
static double poX,poY;//移動用

if( (poX+=2.0)>WIW)poX=-REC;//座標計算
if( (poY+=1.0)>WIH)poY=-REC;

glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);
modelA();
}
//------------------------------------------------------------------------------物体Aの拡大縮小
void modelA_scal()
{
glLoadIdentity();
//拡大縮小
static double scl,vec;//拡大縮小用
if     ( (vec==0)&&(scl+=0.1)>=1 ) {scl=1;vec=1;}
else if( (vec==1)&&(scl-=0.1)<=0 ) {scl=0;vec=0;}

glPushMatrix();
	glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
	glScaled(1.0*scl,1.0*scl,0.0);//拡大縮小
	modelA();
glPopMatrix();

//おまけ　拡大縮小しながら移動
static double poX,poY;//移動用
if( (poX+=1.0)>WIW)poX=-REC;//座標計算
if( (poY+=0.5)>WIH)poY=-REC;
glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);//ずれた分だけ修正
glScaled(scl,scl,0.0);//拡大縮小
modelA();
}
//------------------------------------------------------------------------------物体Aの回転
void modelA_rots()
{
glLoadIdentity();

static double rot;
if( (rot+=1.0)>=360 )rot=0;//回転
glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
glRotated(rot, 0.0, 0.0, 1.0);//回転
modelA();

//おまけ　回転しながら移動
glLoadIdentity();
static double poX,poY;
if( (poX+=0.50)>WIW)poX=-REC;//座標計算
if( (poY+=0.25)>WIH)poY=-REC;
glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);//ずれた分だけ修正
glRotated(360-rot, 0.0, 0.0, 1.0);//回転
modelA();
}
//------------------------------------------------------------------------------物体Aの移動拡大縮小回転
void modelA_msr()
{
glLoadIdentity();

static double poX,poY,scl,vec,rot;//移動+拡大縮小+回転用
if( (poX+=1.2)>WIW)poX=-REC;//座標計算
if( (poY+=1.0)>WIH)poY=-REC;
if     ( (vec==0)&&(scl+=0.0125)>=1 ) {scl=1;vec=1;}//拡大縮小
else if( (vec==1)&&(scl-=0.0125)<=0 ) {scl=0;vec=0;}
if( (rot-=9.0)<=0 )rot=360;//回転

glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);//ずれた分だけ修正
glScaled(scl,scl,0.0);//拡大縮小
glRotated(rot, 0.0, 0.0, 1.0);//回転
modelA();
}
//------------------------------------------------------------------------------物体B
void modelB(GLdouble R,GLdouble G,GLdouble B,GLdouble A)
{
glColor4d(R, G, B, A);//色
glBegin(GL_QUADS);
	glVertex2i(-REC*0.5,-REC*0.5);
	glVertex2i( REC*0.5,-REC*0.5);
	glVertex2i( REC*0.5, REC*0.5);
	glVertex2i(-REC*0.5, REC*0.5);
glEnd();
}
//------------------------------------------------------------------------------物体Bのアルファテスト
void modelB_alph()
{
glLoadIdentity();
glTranslated(WIW/2, WIH/2, 0.0);
modelB(1.0, 0.0, 0.0, 0.4);

//以下、透過アニメーション
static GLdouble alp[3],vec[3],poX,poY,rot;
//アルファ計算
if     ( (vec[0]==0)&&(alp[0]+=0.0025)>1 ){alp[0]=1;vec[0]=1;}
else if( (vec[0]==1)&&(alp[0]-=0.0025)<0 ){alp[0]=0;vec[0]=0;}
if     ( (vec[1]==0)&&(alp[1]+=0.0050)>1 ){alp[1]=1;vec[1]=1;}
else if( (vec[1]==1)&&(alp[1]-=0.0050)<0 ){alp[1]=0;vec[1]=0;}
if     ( (vec[2]==0)&&(alp[2]+=0.0100)>1 ){alp[2]=1;vec[2]=1;}
else if( (vec[2]==1)&&(alp[2]-=0.0100)<0 ){alp[2]=0;vec[2]=0;}
//座標
if( (poX+=0.250)>WIW)poX=-REC;
if( (poY+=0.125)>WIH)poY=-REC;
//回転
if( (rot+=6.0)>360	)rot=0;

glLoadIdentity();//透過2個目
glTranslated(WIW/2+24, WIH/2+24, 0.0);
modelB(0.0, 1.0, 0.0, alp[0]);

glLoadIdentity();//透過3個目
glTranslated(WIW/2+48, WIH/2+48, 0.0);
modelB(0.0, 0.0, 1.0, alp[1]);

glLoadIdentity();//透過4個目
glTranslated(WIW/2+72, WIH/2+72, 0.0);
modelB(1.0, 1.0, 1.0, alp[2]);

glLoadIdentity();//透過回転移動
glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);
glRotated(rot, 0.0, 0.0, 1.0);
modelB(1.0, 1.0, 0.0, alp[1]);
}
//------------------------------------------------------------------------------物体C
void modelC(int div, GLdouble alp)
{
GLdouble poX,poY;
int lop;

glColor4d(1.0, 0.0, 0.0, alp);//色
glBegin(GL_LINE_LOOP);
for(lop=0; lop<div; lop++)//頂点座標計算
  {
  poX=(GLdouble)( (REC/2)*cos(2.0*3.14*lop/div) );
  poY=(GLdouble)( (REC/2)*sin(2.0*3.14*lop/div) );
  glVertex2d(poX, poY);
  }
glEnd();
}
//------------------------------------------------------------------------------物体Cの描画
void modelC_test()
{
glLoadIdentity();

glTranslated(REC*0.5, REC*0.5, 0.0);//ずれた分だけ修正
modelC(16, 1.0);//modelC

//おまけ　移動と透過
glLoadIdentity();
static GLdouble alp,vec,poX,poY;
if     ( (vec==0)&&(alp+=0.02)>1){alp=1; vec=1;}//透過計算
else if( (vec==1)&&(alp-=0.02)<0){alp=0; vec=0;}
if( (poX+=0.75)>WIW)poX=-REC;//座標計算
if( (poY+=1.25)>WIH)poY=-REC;
glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);
modelC(8, alp);//modelC
}
//------------------------------------------------------------------------------物体D
void modelD(GLdouble alp,GLint tex)
{
glBindTexture(GL_TEXTURE_2D, tex);
glColor4d(1, 1, 1, alp);
glBegin(GL_QUADS);
  glTexCoord2i(0, 0);  glVertex2i(-REC*0.5,-REC*0.5);
  glTexCoord2i(1, 0);  glVertex2i( REC*0.5,-REC*0.5);
  glTexCoord2i(1, 1);  glVertex2i( REC*0.5, REC*0.5);
  glTexCoord2i(0, 1);  glVertex2i(-REC*0.5, REC*0.5);
glEnd();
}
//------------------------------------------------------------------------------物体Dの描画
void modelD_test()
{
glLoadIdentity();
glEnable(GL_TEXTURE_2D);//テクスチャON

static GLdouble alp,vec;
if     ( (vec==0)&&(alp+=0.01)>1){alp=1; vec=1;}//透過計算
else if( (vec==1)&&(alp-=0.01)<0){alp=0; vec=0;}

glTranslated(WIW/2+96, WIH/2+96, 0.0);
modelD(alp,texA);//modelD

glDisable(GL_TEXTURE_2D);//テクスチャOFF
}
//------------------------------------------------------------------------------物体DのGIF描画
void modelD_gif()
{
glLoadIdentity();
glEnable(GL_TEXTURE_2D);//テクスチャON

static GLdouble scl,rot,vec,poX,poY;
if( (poX+=0.35)>WIW)poX=-REC;//座標計算
if( (poY+=1.15)>WIH)poY=-REC;
if     ( (vec==0)&&(scl+=0.007)>1 ) {scl=1; vec=1;}//拡大縮小
else if( (vec==1)&&(scl-=0.007)<0 ) {scl=0; vec=0;}
if( (rot+=1.5)>360	)rot=0;//回転

glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);
glScaled(scl,scl,0.0);
glRotated(rot, 0.0, 0.0, 1.0);
modelD(1,texB);//modelD

glDisable(GL_TEXTURE_2D);//テクスチャOFF
}
//------------------------------------------------------------------------------物体DのPNG描画
void modelD_png()
{
glLoadIdentity();
glEnable(GL_TEXTURE_2D);//テクスチャON

static GLdouble scl,rot,vec,poX,poY;
if( (poX+=0.65)>WIW+REC*scl)poX=-REC*scl;//座標計算
if( (poY+=1.75)>WIH+REC*scl)poY=-REC*scl;
if     ( (vec==0)&&(scl+=0.007)>3 ) {scl=3; vec=1;}//拡大縮小
else if( (vec==1)&&(scl-=0.007)<0 ) {scl=0; vec=0;}
if( (rot+=1.5)>360	)rot=0;//回転

glTranslated(poX+REC*0.5, poY+REC*0.5, 0.0);
glScaled(scl,scl,0.0);
glRotated(360-rot, 0.0, 0.0, 1.0);
modelD(1,texC);//modelD

glDisable(GL_TEXTURE_2D);//テクスチャOFF
}
//------------------------------------------------------------------------------物体E
void modelE(GLdouble alp,GLint tex,GLint size)
{
glBindTexture(GTRE, tex);//任意サイズのテクスチャ
glColor4d(1, 1, 1, alp);
glBegin(GL_QUADS);
  glTexCoord2i(   0, 0);    glVertex2i(-size*0.5,-size*0.5);
  glTexCoord2i(size, 0);    glVertex2i( size*0.5,-size*0.5);
  glTexCoord2i(size, size); glVertex2i( size*0.5, size*0.5);
  glTexCoord2i(   0, size); glVertex2i(-size*0.5, size*0.5);
glEnd();
}
//------------------------------------------------------------------------------物体Eのサイズ48描画
void modelE_REC72()
{
glLoadIdentity();
glEnable(GL_TEXTURE_2D);//テクスチャON
glEnable(GTRE);//任意サイズのテクスチャON

static GLdouble alp,vec;
if     ( (vec==0)&&(alp+=0.008)>1){alp=1; vec=1;}//透過計算
else if( (vec==1)&&(alp-=0.008)<0){alp=0; vec=0;}

glTranslated(WIW/2+120, WIH/2+120, 0.0);
modelE(alp,texD,R72);//modelE

glDisable(GTRE);//任意サイズのテクスチャOFF
glDisable(GL_TEXTURE_2D);//テクスチャOFF
}
//------------------------------------------------------------------------------物体Eのサイズ48描画
void modelE_REC48()
{
glLoadIdentity();
glEnable(GL_TEXTURE_2D);//テクスチャON
glEnable(GTRE);//任意サイズのテクスチャON

//以下、移動・拡大縮小・回転
static GLdouble scl,vec,rot,poX,poY;
if     ( (poX-=0.35)<-R48*scl)poX=WIW+(R48*scl)*0.5;//座標計算
else if( (poY-=0.15)<-R48*scl)poY=WIH+(R48*scl)*0.5;
if     ( (vec==0)&&(scl-=0.007)<0 ) {scl=0; vec=1;}//拡大縮小
else if( (vec==1)&&(scl+=0.007)>2 ) {scl=2; vec=0;}	
if( (rot+=1.75)>360	)rot=0;//回転
glTranslated(	poX+R48*0.5,	poY+R48*0.5,0.0);
glScaled(scl,scl,0.0);
glRotated(rot, 0.0, 0.0, 1.0);
modelE(1-scl,texE,R48);//modelE

glDisable(GTRE);//任意サイズのテクスチャOFF
glDisable(GL_TEXTURE_2D);//テクスチャOFF
}
//------------------------------------------------------------------------------物体Eのサイズ24描画
void modelE_REC24()
{
glLoadIdentity();
glEnable(GL_TEXTURE_2D);//テクスチャON
glEnable(GTRE);//任意サイズのテクスチャON

//以下、移動・拡大縮小・回転
static GLdouble scl,vec,rot,poX,poY;
if     ( (poX-=1.75)<-R24*scl)poX=WIW+(R24*scl)*0.5;//座標計算
else if( (poY-=0.65)<-R24*scl)poY=WIH+(R24*scl)*0.5;
if     ( (vec==0)&&(scl-=0.007)<0 ) {scl=0; vec=1;}//拡大縮小
else if( (vec==1)&&(scl+=0.007)>17) {scl=17;vec=0;}	
if( (rot-=1.75)<=0	)rot=360;//回転

glTranslated(	poX+R24*0.5,	poY+R24*0.5,0.0);
glScaled(scl,scl,0.0);
glRotated(rot, 0.0, 0.0, 1.0);
modelE(scl,texF,R24);//modelE

glDisable(GTRE);//任意サイズのテクスチャOFF
glDisable(GL_TEXTURE_2D);//テクスチャOFF
}
//------------------------------------------------------------------------------描画
void modelDrow()
{
modelA_fix();//物体A描画
modelA_move();//移動
modelA_scal();//拡大縮小
modelA_rots();//回転
modelB_alph();//透過
modelA_msr();//移動+拡大縮小+回転
modelC_test();//円の描画
modelD_test();//テクスチャ
modelD_gif();//gifテクスチャ
modelD_png();//pngテクスチャ
modelE_REC72();//任意サイズのテクスチャ　サイズ72
modelE_REC48();//任意サイズのテクスチャ　サイズ48
modelE_REC24();//任意サイズのテクスチャ　サイズ24
}
//------------------------------------------------------------------------------main
int main(int argc,char *argv[])
{
inits();//初期化
while(endKeys()!=0)//メインループ
	{
	back();
	modelDrow();
	
	//フレームレート調整
	now=SDL_GetTicks();
	wit=now-lev;
	if(wit<16)SDL_Delay((16-wit));
	lev=SDL_GetTicks();

	if(now-cntB>=5000)//FPS確認用
		{
		printf("%d\n",cntA/5);
		cntA=1;	cntB=now;
		}	else cntA+=1;
	
	SDL_GL_SwapBuffers();//画面更新
	}
SDL_Quit();
return 0;
}